#include<stdio.h>
#include<string.h>
#define DEBUG 0
#define MAX 128
#define HASH 256
int zadani,hercu,roli,nemoc;
int alter[MAX]; int kteri[MAX][MAX];
int hrana[MAX];
int rroli[MAX]; int ktere[MAX][MAX];
int hraje[MAX];
int level_r[MAX],level_h[MAX];
int svedku_h[MAX],svedci_h[MAX][MAX];
int v_fr,v_fh;
int fr[MAX],fh[MAX];
char jmena_r[HASH][32];
char jmena_h[HASH][32];
int akt_r[HASH],akt_h[HASH],kam_r[HASH],kam_h[HASH];
/* dostane cislo herce */
int vylepsi(int p) {
  int i,k,l;
  if (DEBUG) printf("Vylepsi: %s\n",jmena_h[p]);
  for (i=0; i<svedku_h[i]; i++) {
    k=svedci_h[p][i];	  
    if (level_r[k]==-1) continue;
    if (level_r[k]==0) {
      hrana[k]=p; hraje[p]=k;
      level_r[k]=-1; level_h[p]=-1;
      return 1;
      }
    l=hrana[k];
    if (level_h[l]==-1) continue;
    if (vylepsi(l)) {
      hrana[k]=p; hraje[p]=k;
      level_r[k]=-1; level_h[p]=-1;
      return 1;
      }
    }
  level_h[p]=-1;
  return 0;
  }
int parovani() {
  int i,j;	
  int level;
  if (hercu-nemoc<roli) return 0;
  v_fr=v_fh=0;
  for (i=0; i<roli; i++) hrana[i]=-1;
  for (j=0; j<hercu; j++) hraje[j]=-1;
  while (1) {
      if (DEBUG) {
	printf("Iteration\n");      
        for (i=0; i<roli; i++)
          if (hrana[i]!=-1)
            printf("%s je hrana %s.\n",jmena_r[i],jmena_h[hrana[i]]);	    
        }
    level=0; v_fr=0; v_fh=0;	  
    for (i=0; i<roli; i++) level_r[i]=-1;
    for (i=0; i<hercu; i++) { level_h[i]=-1; svedku_h[i]=0; }
    for (i=0; i<roli; i++) if (hrana[i]==-1) { 
      level_r[i]=0; fr[v_fr++]=i;
      }
    while (v_fr||v_fh) {
      level++;    
      if (v_fr) {
	if (DEBUG) {
		printf("Fronta roli:\n");
		for (i=0; i<v_fr; i++) printf("%s\n",jmena_r[fr[i]]);
	        }
	for (i=0; i<v_fr; i++)
	  for (j=0; j<alter[fr[i]]; j++)
	    if (level_h[kteri[fr[i]][j]]==-1||level_h[kteri[fr[i]][j]]==level){
	      if (level_h[kteri[fr[i]][j]]==-1) {
		fh[v_fh++]=kteri[fr[i]][j];
                level_h[kteri[fr[i]][j]]=level;
	        }
	      svedci_h[kteri[fr[i]][j]][svedku_h[kteri[fr[i]][j]]++]=fr[i];
	      }
	v_fr=0;      
        continue;
        }
	if (DEBUG) {
		printf("Fronta hercu:\n");
		for (i=0; i<v_fh; i++) printf("%s\n",jmena_h[fh[i]]);
	        }
      for (i=0; i<v_fh; i++) if (hraje[fh[i]]==-1) break;
      if (i<v_fh) break;
      for (i=0; i<v_fh; i++) if (level_r[hraje[fh[i]]]==-1) {
	fr[v_fr++]=hraje[fh[i]];
	level_r[hraje[fh[i]]]=level;
        }
      v_fh=0;	      
      }
    for (i=0; i<hercu; i++) if (level_h[i]!=-1&&hraje[i]==-1) break;
    if (i==hercu) break;
    for (;i<hercu; i++) if (level_h[i]!=-1&&hraje[i]==-1) vylepsi(i);	    
    }
  for (i=0; i<roli; i++) if (hrana[i]==-1) return 0;
  return 1;
  }
int absen[MAX];
void newherec(int p,char *q) {
  int a;
  char *c;	
  for (a=0, c=q; *c; c++) a=(a+*c)&HASH;
  while (akt_h[a]==zadani) a=(a+1)&(HASH-1);
  strcpy(jmena_h[a],q);
  akt_h[a]=zadani;
  kam_h[a]=p;
  }
void newrole(int p,char *q) {
  int a;
  char *c;	
  for (a=0, c=q; *c; c++) a=(a+*c)&HASH;
  while (akt_r[a]==zadani) a=(a+1)&(HASH-1);
  strcpy(jmena_r[a],q);
  akt_r[a]=zadani;
  kam_r[a]=p;
  }
int getherec(char *p) {
  int a;
  char *c;	
  for (a=0, c=p; *c; c++) a=(a+*c)&HASH;
  for (; strcmp(jmena_h[a],p); ) a=(a+1)&(HASH-1);
  return kam_h[a];
  }
int getrole(char *p) {
  int a;
  char *c;	
  for (a=0, c=p; *c; c++) a=(a+*c)&HASH;
  for (; strcmp(jmena_r[a],p); ) a=(a+1)&(HASH-1);
  return kam_r[a];
  }
int main() {
  char s[100];
  int i,j,k,l;
  scanf("%d",&zadani);
  for (i=0; i<HASH; i++) akt_h[i]=akt_r[i]=zadani;
  while (zadani--) {
    scanf("%d %d %d\n",&hercu,&roli,&nemoc);
    for (i=0; i<hercu; i++) {
      scanf("%s",s);
      newherec(i,s);
      rroli[i]=absen[i]=0;
      }
    for (i=0; i<roli; i++) {
      alter[i]=0;
      scanf("%s",s);
      newrole(i,s);
      }
    for (i=0; i<hercu; i++) {
      scanf("%s",s);
      k=getherec(s);
      scanf("%d",&j);
      while (j--) {
        scanf("%s",s);
	l=getrole(s);
	kteri[l][alter[l]++]=k;
	ktere[k][rroli[k]++]=l;
        }
      }
    for (i=0; i<nemoc; i++) {
      scanf("%s",s);
      k=getherec(s);
      absen[k]=1;
      }
    for (i=0; i<roli; i++) {
      for (j=k=0; k<alter[i]; k++) {
        if (!absen[kteri[i][k]]) kteri[i][j++]=kteri[i][k];
        }
      alter[i]=j;	
      }
    if (parovani()) printf("Premiera bude!\n"); else printf("Zatraceni demonstranti!\n");
    }
  return 0;
  }
